﻿//TOC_Poems_v5.2.jsx
var starStr ="";
var poemStyleName; // имя стиля которым оформлены стихотворные строки
var poemStyle = getParagraphStyleByName(poemStyleName); 

main();
function main()
{
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if(app.selection.length ==0 || app.selection[0].constructor.name != "InsertionPoint")
{
    alert("Поставьте курсор в текст содержания и попробуйте снова.");
    exit();
}

    var myParaStyleNames = myGetParagraphStyleNames();
    var myTOCStory = app.selection[0].parentStory;
    app.findGrepPreferences.findWhat = "^\\* ?\\* ?\\*";
    var myFoundItems = myTOCStory.findGrep();
    if(myFoundItems.length>0) {
    starStr = myFoundItems[0].contents;    
    }
// -------------ВЫЗЫВАЕМ ДИАЛОГ-------------------
myWin = CreatePalette(myParaStyleNames); 
//---------------------------------------------------------------
    if ( myWin.show()  == 1 ) 
    {  
        // Устанавливаем таймер
        var timeDiff = 
        {
	    setStartTime:function (){d = new Date(); time  = d.getTime();},
	    getDiff:function (){d = new Date(); t = d.getTime() - time; time = d.getTime(); return t;}
        }
        timeDiff.setStartTime(); // - старт таймера
        
// ЗАПУСКАЕМ ОСНОВНУЮ РАБОЧУЮ ФУНКЦИЮ
        letsGo(myTOCStory);
        alert("Готово! Время выполнения " + timeDiff.getDiff() / 1000 + " seconds", "Время работы");
     }  //if
} // main()

function CreatePalette(pStyleList) 
{
    myDialog = new Window('dialog', 'Исходные данные');
    this.windowRef = myDialog;
    myDialog.orientation = "column";
    myDialog.alignChildren = ['fill', 'fill'];
 
    myDialog.pnl1 = myDialog.add("panel", undefined, "[1]");
    myDialog.pnl1.alignChildren =['fill', 'fill'];// 'left';
    myDialog.pnl1.orientation = 'row';
    myDialog.pnl1.stxt = myDialog.pnl1.add("statictext", undefined, "Помещать в содержание первую строчку стиха вместо ");
    myDialog.pnl1.etxt = myDialog.pnl1.add("edittext", undefined, starStr);
    myDialog.pnl1.etxt.characters = 8;
    
    myDialog.pnl2 = myDialog.add("panel", undefined, "[2]");
    myDialog.pnl2.dropdown = myDialog.pnl2.add("dropdownlist", undefined, pStyleList);
    myDialog.pnl2.dropdown.title = "Стиль стихотворных строчек";
    myDialog.pnl2.dropdown.selection=0;
    
   // добавляем кнопки завершения диалога
    var myGroup = myDialog.add( "group" );
    myGroup.orientation = 'row';
    myGroup.okButton = myGroup.add( "button", undefined, "Поехали" );
    myGroup.okButton.onClick = function() 
    { 
        // Проверка, данных
        if(myDialog.pnl1.etxt.text == '')
        {
            alert("Задайте параметр");
            return;
        }
        else
        {
            starStr= myDialog.pnl1.etxt.text;
        }
        poemStyleName = myDialog.pnl2.dropdown.selection.text;
          
        // Закрытие диалога
        myDialog= this.window.close( 1 );
    } // fnc
    myGroup.cancelButton = myGroup.add( "button", undefined, "Cancel" );
    myGroup.cancelButton.onClick = function() { myDialog = this.window.close( 0 ); }
    
return myDialog;
 }

function myGetParagraphStyleNames()
// Получаем список стилей абзацев 
{
	var curGroup;
	var curGroupName;
	var curNameInGroup;
	var myParagraphStyleNames = app.activeDocument.paragraphStyles.everyItem().name;
	myParagraphStyleNames.shift(); // удаление стиля No Paragraph Style
	var paraGroups = app.activeDocument.paragraphStyleGroups;
	var paraGroupsLen = paraGroups.length;
	for(var i = 0; i < paraGroupsLen; i++) {
		curGroup = paraGroups[i];
		curGroupName = paraGroups[i].name;
		curGroupStyleNames = curGroup.paragraphStyles.everyItem().name
		for (j=0; j< curGroupStyleNames.length; j++)
		{
			curNameInGroup = curGroupName +":"+ curGroupStyleNames[j];
			myParagraphStyleNames.push(curNameInGroup);
		}
	}
	return myParagraphStyleNames;
}

function getParagraphStyleByName(myStyleName)
{
	var DocParaStyles = app.activeDocument.paragraphStyles;
	var DocParaGroups = app.activeDocument.paragraphStyleGroups;
	myStyleName = ""+myStyleName;
	var pos = myStyleName.indexOf(":")
	if(pos == -1)
	{
	// стиль не в группе
	var myStyle = DocParaStyles.item(myStyleName);
		return myStyle;
	} //if
	else
	{
		var myGroupAndStyleNames = myStyleName.split(":")
		var myGroupName = myGroupAndStyleNames[0];
		var myStyleName = myGroupAndStyleNames[1];
		var myGroup =DocParaGroups.item(myGroupName);
		return myGroup.paragraphStyles.item(myStyleName);

	}
} // fnc

function getParagraphStyleNameFromObjParagraph(/* obj*/ pstyle)
{
    var myParagraphStyles = app.activeDocument.paragraphStyles;
    for( var i =0 ; i< myParagraphStyles.length; i++)
    {
        if(myParagraphStyles[i] == pstyle)
        return myParagraphStyles[i].name;
    }
var paraGroups = app.activeDocument.paragraphStyleGroups;
var curGroup, curGroupStyles;
    for(i =0; i < paraGroups.length; i++)
    {
		curGroup = paraGroups[i];
		curGroupStyles = curGroup.paragraphStyles;
        for (var j=0; j< curGroupStyles.length; j++)
		{
                if(curGroupStyles[j] == pstyle)
                {
                    var curGroupName = curGroup.name;
                    var curStyleName = curGroupName +":"+ curGroupStyles[j].name;
                    return curStyleName;
                }
		}
    }
alert("getParagraphStyleNameFromObjParagraph - стиль не определен")
return null;
 }

/**********ОСНОВНАЯ РАБОЧАЯ ФНКЦИЯ****************/
function letsGo(TOCStory)
{
var doc = app.activeDocument;
var firstStr;
var myChangeTo =[];
    
    resetGREPfindChange();
      
    var strForFind = '^' + starStr.replace(/\*/g,  "\\\*") +"\\r";
    app.findGrepPreferences.findWhat = strForFind ;
    var myFoundItems = doc.findGrep();
    if(!myFoundItems.length) 
    {
        alert("В тексте нет " +starStr); return;
    }
    else
    {
        //alert("Найдено звездных заголовков в основном тексте " + myFoundItems.length); 
    }
    // Собираем коллекцию звездных заголовков в содержании
    resetGREPfindChange();
    strForFind = '^' + starStr.replace(/\*/g,  "\\\*");
    app.findGrepPreferences.findWhat = strForFind ;
    var TOCFoundItems = TOCStory.findGrep();
    if(!TOCFoundItems.length) 
    {
        alert("В содержании нет " +starStr); return;
    }
    else
    {
        //alert("Найдено звездных заголовков в содержании " + TOCFoundItems.length); 
    }
if(myFoundItems.length != TOCFoundItems.length)
{
    alert('Количество звездных заголовков в документе не совпадает с количеством звездных заголовков в содержании\n. Продолжение работы не имеет смысла. Устраните несоответствие и попробуйте снова');
    exit();
}
// ---------------данные для прогрессбара --------------	
    var myProgressBarWidth = 300;
	var myMaximumValue = myFoundItems.length;
	var myIncrement = myProgressBarWidth/myMaximumValue;
	var myProgressPanel = myCreateProgressPanel(myProgressBarWidth);
	myProgressPanel.show();
	myProgressPanel.myProgressBar.value = myProgressBarWidth;
	myProgressPanel.progrPanelMessage.enabled = false;
//--------------------------------------------------------------------------------------------

// Замена звездочек, найденных в стихах, на первую строку стиха
    for(var i=0; i <myFoundItems.length; i++)
    {
        myProgressPanel.progrPanelMessage.text = "Сбор данных в тексте: " + (i+1) +" из " +myFoundItems.length ;
        //firstStr = firstStr.slice(0,-1); // отрезаем последний знак - \r
        //firstStr = getFirst(myFoundItems[i]);
        firstStr = getFirst1(myFoundItems[i]); // Альтернативная функция
        
        myChangeTo.push(firstStr);
        myProgressPanel.myProgressBar.value = myIncrement * i;
    } // конец цикла

// Заполнение содержания
    for(i=0; i <TOCFoundItems.length ; i++)
    {
        myProgressPanel.progrPanelMessage.text = "Обработка содержания: " + (i+1) +" из " +TOCFoundItems.length ;
        TOCFoundItems[i].contents = myChangeTo[i];
        myProgressPanel.myProgressBar.value = myIncrement * i;
    }
    myProgressPanel.hide();
} // fnc

function getFirst(myFoundItem)
{
 var nextPara, curPara
    var myPara = myFoundItem.paragraphs[0];
    var myStory = myFoundItem.parentStory;
    var myParagraphs = myStory.paragraphs;
    curPara = myPara;
    var counter =0;
do {
        nextPara = myParagraphs.nextItem(curPara);
        nextParaStyleName = getParagraphStyleNameFromObjParagraph(nextPara.appliedParagraphStyle);
        curPara = nextPara;
        counter ++;
         if(counter  == 5) { 
             alert("Страница " +curPara.parentTextFrames[0].parentPage.name+"\nНевозможно найти первую строку стиха\nВозможно абзацный стиль стиха не соответствует заданному в диалоговом окне\nЗвездочки в содержании не будут заменены"); 
             return myFoundItem.contents; }
    }while(nextParaStyleName != poemStyleName);
    
    var firstStr = removePunctuation(curPara.contents); 
return firstStr;   
} // fnc
//********************************************************************
// Альтернативная функция получения первой строки стиха
function getFirst1(myFoundItem)
{
 var nextPara, curPara, myIndex, myChar;
    var myPara = myFoundItem.paragraphs[0];
    var myStory = myFoundItem.parentStory;
    curPara = myPara;
    var counter =0;
    do {
        
        var lastCharCurParaIndex = curPara.characters[-1].index;
        var firstCharNextPara = curPara.parentStory.characters[lastCharCurParaIndex +1];
        nextPara = firstCharNextPara.paragraphs[0];
         nextParaStyleName = getParagraphStyleNameFromObjParagraph(nextPara.appliedParagraphStyle);
         curPara = nextPara;
        counter ++;
        if(counter  == 5) { // curPara.parentTextFrames[0].parentPage.name + "\r"
             alert("Страница " +curPara.parentTextFrames[0].parentPage.name+"\nНевозможно найти первую строку стиха\nВозможно абзацный стиль стиха не соответствует заданному в диалоговом окне\nЗвездочки в содержании не будут заменены"); 
             return myFoundItem.contents; }

    } while(nextParaStyleName != poemStyleName);
    var firstStr = removePunctuation(curPara.contents);

return firstStr;   
}

//-------------Удаление пунктуации -------------------------
function removePunctuation(myStr)
{ 
    
// 13 - знак конца абзаца. 32 - пробел, 33 - восклик. знак; 40 и 41 - скобки открывающая и закрывающая; Звездочка (*) - 42; 44 - запятая; 45- дефис; 46 - точка; 58 - двоеточие; 63 - вопросит. знак; 8211 - короткое тире; 8312 - длинное тире
// 8220, 8221, 8222 - кавычки-лапки, надо разобраться что есть что.
// 8230 - многоточие один знаком
// кавычки русские, "ёлочки" - 171 и 187
// 34 - кавычки двойные, так?
//
// Получить символ из кода можно так: alert( String.fromCharCode(nomer кода) )

// Получить код первого символа из выделенной строки в индизайне
//if(app.selection.length != 0) {
//myStr = app.selection[0].contents;
//alert("код первого символа из выделенного текста = "+myStr.charCodeAt(0));
//}

var mySign;
var i = myStr.length - 1;
var flag = true;
		while (flag) {
            var cod = myStr.charCodeAt(i);
            switch(cod)
            {
                case 33:
                        mySign = '!';
                        i--;
                        break;
                case 63:
                        i--;
                        mySign = '?';
                break;
                case 13:
                case 32:
                case 45:
                case 44: // запятая
                case 46: // точка 
                case 58: // двоеточие 
                case 187:
                case 8198:
                case 8201: // Thin Space
                case 8202: // волосяной пробел Hair Space
                case 8211:
                case 8212:
                case 8230: // многоточие (лигатура)
                        i--;
                break;
                default: flag = false;
                
            }//switch                  
        }// while
    // Удаление начальной кавычки
   cod = myStr.charCodeAt(0);
   if(cod == 171)
   {
       myStr = myStr.substring(1) // удаляем кавычку (если она есть) - первый символ строки, чтобы избежать двойных кавычек вначале
       i--;
   }
   
    // return block
    switch (mySign)
    {
        case '!':
        case '?':
            return ('\"' + myStr.substr(0, i+1) + mySign+"..\""); 
        break;
        default:
            return ('\"' + myStr.substr(0, i+1) + "...\""); 
        break;
    }
        

//старый код:
/*
var i = myStr.length - 1;
var cont = true;
		
		while (cont) {
			var cd = myStr.charCodeAt(i);
			if ((cd == 13)||(cd == 32)||(cd == 46)||(cd == 44)||
				(cd == 33)||(cd == 63)||(cd == 8212)||(cd == 8211)||(cd == 45)) {
				i --;
			}
			else cont = false;
		}
		
		return ("\"" + myStr.substr(0, i+1) + "...\""); */

} // end fnc

//-------------------fnc --------------------
function resetGREPfindChange()
{
    app.changeGrepPreferences = NothingEnum.nothing;
    app.findGrepPreferences = NothingEnum.nothing;
    app.findChangeGrepOptions.includeFootnotes = false;
    app.findChangeGrepOptions.includeHiddenLayers = false;
    app.findChangeGrepOptions.includeLockedLayersForFind = false;
    app.findChangeGrepOptions.includeLockedStoriesForFind = false;
    app.findChangeGrepOptions.includeMasterPages = false;
}

function myCreateProgressPanel(myProgressBarWidth){
	myProgressPanel = new Window('window', 'Progress Converting');
	with(myProgressPanel){
		myProgressPanel.myProgressBar = add('progressbar', [12, 12, myProgressBarWidth, 24], 0, myProgressBarWidth);
		myProgressPanel.progrPanelMessage = add('edittext', [12, 12, myProgressBarWidth, 36], "");
	}
	return myProgressPanel; //myProgressPanel.progrPanelMessage.enabled = false;
} // fnc



